// src/backend/serializer.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef XML_SERIALIZER_HH
#define XML_SERIALIZER_HH 1

#include "config.h"
#include "backend/serializer.hh"

#include <glibmm/ustring.h>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>

namespace sgpem
{
  class XMLSerializer;

  class XMLSerializer : public Serializer
  {
  public:
    XMLSerializer();
    virtual ~XMLSerializer();

    virtual void save_snapshot(const Glib::ustring& filename, const History& hist);
    virtual void restore_snapshot(const Glib::ustring& filename, History& hist);
    virtual const Glib::ustring get_filename_extension();
    virtual const Glib::ustring get_filename_description();
  protected:
  private:
    void fill_doc(xmlDocPtr doc, const History& hist);
    void fill_resources(xmlNodePtr doc, const History& hist);
    void fill_schedulables(xmlNodePtr doc, const History& hist);
  };
}

#endif
